
#include <sys/types.h> //per la mkfifo, fork, wait, open, kill
#include <sys/stat.h>  //per la mkfifo, open
#include <unistd.h>   //per la fork, read,close,
#include <fcntl.h> //per la open,
#include <sys/wait.h> //per la wait,
#include <signal.h>    //per la kill

#include "salvo_utility.h"
#include "sysmacro.h"  //macro di utilit



#define DATABASE "/tmp/Freetel.db"
void changeState( int, int, char[], char);
void posizione( int, int); 
database db;

int main ()
{ 
  int n, fd, pid, fdstate,  fdSMSpipe, fdChiamatapipe1, fdChiamatapipe2;
  
 
  int letti;
  char messaggio[MASX];
  
  char nomepipe1[DIM];
  char nomepipe2[DIM];
  
  
  message2 m;
  
  
  IFERROR(pid = fork(),"forkandosi");
  
  
  if (pid==0) //Siamo nel figlio
    {
      if(isfile(DATABASE))   // elimino il DATABASE precedente
	unlink(DATABASE);
      
      if(!ispipe(PIPE)) 
	{
	  IFERROR(mkfifo(PIPE,0644),"Nella creazione di FREETEL.pipe");
	  //  printf("\nIl pipe FREETEL.pipe  stato creato\n");
	} //end  if(!ispipe(PIPE)) 
      
      
      IFERROR(fdstate=open(DATABASE,O_RDWR|O_CREAT, 0644),"errore in apertura");  //apertura database
      IFERROR(fd = open(PIPE, O_RDONLY), "Nell'apertura di FREETEL.pipe"); //apertura pipe
      
      while (5==5)
	{
	  while((n=read(fd,&m, sizeof(m)))>0 ) 
	    {
	      switch(m.type)
		{
		case 1: //G e s t i o n e  d e l l o  s t a t o   d i   u n   c e l l u l a r e 
 		  {                                                             

		    //printf( "Dim messaggio: %d  |%d|%s|%c|\n",sizeof(m),m.myNumber, m.mytty,m.u.state );
		    changeState( fdstate, m.myNumber, m.mytty, m.u.state);
		   
		    break;
		  } 
		  
		case 2: //S M S 
		  {
		    
		    //-----------ceck per sapere se il numero passato  presente nel database-------------
		    //printf("Dim messaggio arrivato: %d\n", sizeof(m));
		    posizione(fdstate, m.u.called);
		    if(db.state== 'R')
		      {
			IFERROR3(kill( m.u.sm.called, SIGUSR2), "Nell'invio di SIGUSR2", kill( m.myNumber, SIGTERM));
			
			//printf("Ho inviato il segnale SIGUSR2 a %d \n",m.u.sm.called);
			sprintf(messaggio,"\nSMS by %d:  %s\n", m.myNumber, m.u.sm.mess);
			sprintf(nomepipe1,"/tmp/%d.pipe",m.u.sm.called);
			if(!ispipe(nomepipe1)) 
			  IFERROR(mkfifo(nomepipe1,0644),"Nella creazione del pipe per invio SMS");   //creazione pipe
			IFERROR(fdSMSpipe = open(nomepipe1, O_WRONLY), "Nell'apertura del pipe per invio SMS"); //apertura pipe
			IFERROR(write(fdSMSpipe, messaggio,(MASX*sizeof(char))),"Nella  scrittura del pipe per invio SMS"); // ho scritto l'SMS nel pipe
			IFERROR(close(fdSMSpipe), "Nella chiusura del pipe");
		      }
		    else   // da gestire il caso di assenza nel database
		      {
			
			IFERROR(kill( m.myNumber, SIGTERM), "Nell'invio del SIGTERM al chiamante");
			//printf("Ho inviato a %d un SIGTERM perch l' utente %d non era libero\n", m.myNumber,m.u.sm.called);
		      }
		   
		    break;
		  }
		case 3:   //T e l e f o n a t a 
		  {
		    
		    posizione(fdstate, m.u.called);
		    if(db.state == 'R') 
		      {
			sprintf(nomepipe1,"/tmp/%d.pipe",m.u.called);                               //formazione nome pipe per chiamato
			sprintf(nomepipe2,"/tmp/%d.pipe",m.myNumber);                               //formazione nome pipe per chiamante
			
			if(!ispipe(nomepipe1)) 
			  IFERROR(mkfifo(nomepipe1,0644),"Nella creazione del pipe del chiamato");   //creazione pipe
			if(!ispipe(nomepipe2)) 
			  IFERROR(mkfifo(nomepipe2,0644),"Nella creazione del pipe del chiamante");   //creazione pipe
				
			IFERROR3(kill(m.u.called, SIGUSR1), "Nell'invio di SIGUSR1 al chiamato", kill( m.myNumber, SIGTERM));  //invio segnale
			IFERROR (kill(m.myNumber, SIGUSR1), "Nell'invio di SIGUSR1 al chiamante");      // invio segnale
			
			IFERROR(fdChiamatapipe1 = open (nomepipe1, O_WRONLY), "Nell'apertura del pipe per invio tty al chiamato"); //apertura pipe 
			IFERROR(fdChiamatapipe2 = open (nomepipe2, O_WRONLY), "Nell'apertura del pipe per invio tty al chiamante"); //apertura pipe
			//printf("Ho inviato il segnale sia a %d sia a %d con tty: %s e %s\n", m.myNumber, m.u.called, m.mytty, db.tty );	
			posizione(fdstate, m.myNumber);
			//printf("info chiamante: |%d|%s|%c|\n", db.number, db.tty, db.state);
			IFERROR(write(fdChiamatapipe1,&db,(sizeof(database))),"Nella scrittura del pipe per invio informazioni al chiamato");
			//printf("Ho inviato al chiamato (%d) le informazioni del chiamante (%d)\n",m.u.called, m.myNumber);
			posizione(fdstate, m.u.called);
			//printf("info chiamato: |%d|%s|%c|\n", db.number, db.tty, db.state);
			IFERROR(write(fdChiamatapipe2,&db,(sizeof(database))),"Nella  scrittura del pipe per invio tty al chiamante"); 
			//printf("Ho inviato al chiamante (%d) le informazioni del chiamato (%d)\n", m.myNumber, m.u.called );
			changeState( fdstate, m.myNumber, m.mytty,'O');
			changeState( fdstate, m.u.called, db.tty,'O');
			
			IFERROR(close(fdChiamatapipe1), "Nella chiusura del pipe del chiamato");   //Chiusura Pipe
			IFERROR(close(fdChiamatapipe2), "Nella chiusura del pipe del chiamante"); //Chiusura Pipe
		      } //end if (db.state == 'R') 
		    else 
		      {
			IFERROR(kill( m.myNumber, SIGTERM), "Nell'invio del SIGTERM al chiamante");
		      } 
		    
		   
		    break;
		  }
		case 4: //Lista telefoni
		  {
		    
		    
		    // printf("Dim messaggio arrivato: %d\n", sizeof(m));
		    //printf("Mi  arrivata una richiesta di lista da %d\n",m.myNumber);
		    sprintf(nomepipe2,"/tmp/%d.pipe",m.myNumber); 
			    
		    if(!ispipe(nomepipe2)) 
		      {
			IFERROR(mkfifo(nomepipe2,0644),"Nella creazione del pipe per inviare la lista");
				
		      } //end  if(!ispipe(PIPE)) 
		    
		    IFERROR(fdSMSpipe = open(nomepipe2, O_WRONLY), "Nell'apertura del pipe per invio lista"); //apertura pipe
			    
		    lseek(fdstate, 0, SEEK_SET);  
		    //---invio solo i record del database avente stato != da spento escluso quello del chiamante----		
		    while((letti= read(fdstate,&db,(sizeof(database))))>0)
		      {
			if((db.state != 'S')&& (db.number != m.myNumber))
			  IFERROR(write(fdSMSpipe,&db,letti ), "In scrittura sul pipe del cellulare");  
			
		      } //end while((letti= read(fdstate,&db,(sizeof(database))))>0)
		    
		    IFERROR(close(fdSMSpipe), "Nella chiusura del pipe");
		    //printf("Lista inviata a %d\n", m.myNumber);
		    break;
		  } //end case 4
		  
		}  //end switch(m.type)
	    
	    } //end while((n=read(fd,&m, sizeof(m)))>0 ) 

	  //  waitpid(sottopidstato, &status, WNOHANG);
	} //end while (5==5) 
      
    } //end if figlio
  
  
  return (0);
}//end main



void changeState( int fdi, int myNum, char mytty[MA], char stat)
{  
  strcpy( db.tty, mytty);
  
  db.number = myNum;
  db.state= stat;
  
  lseek(fdi, (sizeof(database))*(myNum % MOD), SEEK_SET);
  write(fdi, &db ,(sizeof(database)));
  
} //end changeState


void posizione( int fdi, int Num) 
     
{
  lseek(fdi, (sizeof(database))*(Num % MOD), SEEK_SET);
  IFERROR(read (fdi,&db,(sizeof(database))),"in lettura dal database");
}  // end posizione
